<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/ByteBuffer.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/ByteBuffer.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 25 april 2009, 15:59</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef BYTEBUFFER_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define BYTEBUFFER_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "<a class="code" href="_common_8h.html" title="This file is a shortcut to include many commonly used headers.">Common.h</a>"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "../IO/InputStream.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "../IO/OutputStream.h"</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 SYLPH_BEGIN_NAMESPACE
<a name="l00029"></a>00029 SYLPH_PUBLIC
<a name="l00030"></a>00030 
<a name="l00034"></a><a class="code" href="class_sylph_1_1_byte_buffer.html">00034</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a> : <span class="keyword">public</span> InputStream, <span class="keyword">public</span> OutputStream {
<a name="l00035"></a>00035     <span class="keyword">friend</span> OutputStream&amp; operator&lt;&lt;(OutputStream&amp;, <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp;);
<a name="l00036"></a>00036     <span class="keyword">friend</span> InputStream&amp; operator&gt;&gt;(InputStream&amp;, <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp;);
<a name="l00037"></a>00037 <span class="keyword">public</span>:
<a name="l00038"></a>00038     <span class="keyword">enum</span> Traits {
<a name="l00039"></a>00039         Closed = 0x00,
<a name="l00040"></a>00040         Read = 0x01,
<a name="l00041"></a>00041         Write = 0x02,
<a name="l00042"></a>00042         ReadWrite = 0x03,
<a name="l00043"></a>00043         RW = ReadWrite
<a name="l00044"></a>00044     };
<a name="l00045"></a>00045     <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>(Traits traits = RW, <span class="keywordtype">size_t</span> bufsize = 16);
<a name="l00046"></a>00046     <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_array.html">Array&lt;byte&gt;</a> &amp; ar);
<a name="l00047"></a>00047     <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp; orig);
<a name="l00048"></a>00048     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>();
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="comment">// common methods</span>
<a name="l00051"></a>00051     
<a name="l00052"></a>00052     fsize_t available() <span class="keyword">const</span>;
<a name="l00053"></a>00053     <span class="keywordtype">void</span> close();
<a name="l00054"></a>00054     <span class="keywordtype">bool</span> eof() <span class="keyword">const</span>;
<a name="l00055"></a>00055     <span class="keywordtype">bool</span> markSupported()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00056"></a>00056     <span class="keywordtype">void</span> mark(fsize_t);
<a name="l00057"></a>00057     fsize_t skip(fsize_t);
<a name="l00058"></a>00058     <span class="keywordtype">void</span> reset();
<a name="l00059"></a>00059     <span class="keywordtype">size_t</span> size() <span class="keyword">const</span>;
<a name="l00060"></a>00060     <span class="keywordtype">void</span> clear();
<a name="l00061"></a>00061     
<a name="l00062"></a>00062     <span class="comment">// traits modifiers</span>
<a name="l00063"></a>00063     
<a name="l00064"></a>00064     <span class="keywordtype">void</span> setTraits(Traits traits);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="comment">// Read methods</span>
<a name="l00067"></a>00067     InputStream&amp; operator&gt;&gt;(byte&amp; b);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="comment">// Write methods and operators</span>
<a name="l00070"></a>00070     OutputStream&amp; operator&lt;&lt;(<span class="keyword">const</span> byte b);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp; fromString(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> s);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="comment">// Operators:</span>
<a name="l00075"></a>00075     <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a> &amp; rhs);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="comment">// Convertors:</span>
<a name="l00078"></a>00078     
<a name="l00079"></a>00079     <a class="code" href="class_sylph_1_1_array.html">Array&lt;byte&gt;</a> toArray();
<a name="l00080"></a>00080     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_array.html">Array&lt;byte&gt;</a> toArray() <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     operator Array&lt;byte&gt;();
<a name="l00083"></a>00083     operator const Array&lt;byte&gt;() <span class="keyword">const</span>;
<a name="l00084"></a>00084 <span class="keyword">private</span>:
<a name="l00085"></a>00085     <span class="keywordtype">void</span> ensureCapacity(<span class="keywordtype">size_t</span> capacity);
<a name="l00086"></a>00086     <a class="code" href="class_sylph_1_1_array.html">Array&lt;byte&gt;</a> _array;
<a name="l00087"></a>00087     idx_t _pos;
<a name="l00088"></a>00088     <span class="keywordtype">size_t</span> _size;
<a name="l00089"></a>00089     Traits _traits;
<a name="l00090"></a>00090     idx_t _mark;
<a name="l00091"></a>00091     <span class="keywordtype">size_t</span> _markExpires;
<a name="l00092"></a>00092 };
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 OutputStream&amp; operator&lt;&lt;(OutputStream&amp;, <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp;);
<a name="l00095"></a>00095 InputStream&amp; operator&gt;&gt;(InputStream&amp;, <a class="code" href="class_sylph_1_1_byte_buffer.html">ByteBuffer</a>&amp;);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 SYLPH_END_NAMESPACE
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#endif  </span><span class="comment">/* BYTEBUFFER_H_ */</span>
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
